IncludeScript("_charlib/weapons.nut")
IncludeScript("_charlib/weapon_models.nut")

function ConvertToCustomCharacter()
{
    self.Regenerate(true);
    if (self.InCond(TF_COND_AIMING))
        RunWithDelay(0.1, function()
        {
            for (local i = 0; i < 10; i++)
            {
                local weapon = GetPropEntityArray(self, "m_hMyWeapons", i);
                if (weapon)
                {
                    self.Weapon_Switch(weapon);
                    return;
                }
            }
        });
}

OnSelfGameEvent("post_inventory_application", -10, function()
{
    self.SetPlayerClass(characterClass);
    self.SetCustomModelWithClassAnimations(characterModel);

    foreach(item in self.GetWeaponsAndCosmetics())
        item.Kill();
});

function ClearCustomCharacter(roundStart = false)
{
    FireCustomEvent("clear_custom_character", {
    	userid = self.GetUserID()
    });
    delete self.GetScriptScope()["characterName"];
    self.KeyValueFromString("targetname", "");
    local entsToKill = [];
    for (local child = self.FirstMoveChild(); child != null; child = child.NextMovePeer())
        if (safeget(child.GetScriptScope(), "characterName", null))
            entsToKill.push(child);
    foreach (ent in entsToKill)
        ent.Kill();
    if (roundStart)
        self.SetCustomModelWithClassAnimations("");
    else
        RunWithDelay(0.1, function(player){
            if (IsValidPlayer(player))
                player.SetCustomModelWithClassAnimations("");
        }, self, main_script);
    self.TerminateScriptScope();
}
OnSelfGameEvent("player_death", 9999999, ClearCustomCharacter);

OnSelfGameEvent("player_disconnect", 0, function()
{
    self.TakeDamageCustom(
        self,
        self,
        self.GetActiveWeapon(),
        Vector(),
        Vector(),
        99999
        0,
        TF_DMG_CUSTOM_TELEFRAG);
});