IncludeScript("_charlib/weapons.nut")
IncludeScript("_charlib/weapon_models.nut")

function ConvertToCustomCharacter()
{
    self.Regenerate(true);
    if (self.InCond(TF_COND_AIMING))
        RunWithDelay(0.1, function()
        {
            for (local i = 0; i < 10; i++)
            {
                local weapon = GetPropEntityArray(self, "m_hMyWeapons", i);
                if (weapon)
                {
                    self.Weapon_Switch(weapon);
                    return;
                }
            }
        });
    //self.RemoveCond(TF_COND_AIMING);
}

OnSelfEvent("post_inventory_application", -10, function()
{
    self.SetPlayerClass(characterClass);
    self.SetCustomModelWithClassAnimations(characterModel);
    self.SetModelScale(safeget(self, "characterScale", 1), 0);

    foreach(item in self.GetWeaponsAndCosmetics())
        item.Kill();
});

function ClearCustomCharacter(roundStart = false)
{
    FireCustomEvent("clear_custom_character", {
    	userid = self.GetUserID()
    });
    delete self.GetScriptScope()["characterName"];
    self.KeyValueFromString("targetname", "");
    foreach(item in self.GetAttachments())
        item.Kill();
    if (roundStart)
        self.SetCustomModelWithClassAnimations("");
    else
        RunWithDelay(0.1, function(player) {
            if (IsValidPlayer(player))
                player.SetCustomModelWithClassAnimations("");
        }, self, main_script);
    self.TerminateScriptScope();
}
OnSelfEvent("player_death", 1000, ClearCustomCharacter);

function KillToPreventBugs()
{
    self.TakeDamageCustom(
        self,
        self,
        self.GetActiveWeapon(),
        Vector(),
        Vector(),
        99999
        0,
        TF_DMG_CUSTOM_TELEFRAG);
}

OnSelfGameEvent("player_disconnect", 0, KillToPreventBugs);
OnSelfGameEvent("player_team", 0, KillToPreventBugs);