weaponModels <- [];

function RefreshModels()
{
    local weaponEnt = self.GetActiveWeapon();
    local weaponTT = GetWeaponTypeFromEntity(weaponEnt);
    if (!weaponTT)
        return;

    foreach (ent in weaponModels)
        if (ent.IsValid())
            ent.Kill();
    weaponModels <- [];

    //SetPropBool(weaponEnt, "m_bBeingRepurposedForTaunt", true);
    local viewModel = GetPropEntity(self, "m_hViewModel");
    viewModel.DisableDraw();

    if ("customArms" in weaponTT)
        CreateViewModel(weaponTT.customArms, true);
    else if ("characterArms" in this)
        CreateViewModel(characterArms, true);

    if ("animmodel" in weaponTT)
    {
        weaponEnt.SetModelSimple(weaponTT.animmodel);
        weaponEnt.SetCustomViewModelModelIndex(GetModelIndex(weaponTT.animmodel));
        SetPropInt(weaponEnt, "m_iViewModelIndex", GetModelIndex(weaponTT.animmodel));

        self.Weapon_Switch(weaponEnt);
        viewModel.DisableDraw();
    }
    if ("weaponmodel" in weaponTT)
    {
        CreateViewModel(weaponTT.weaponmodel, true);
        CreateWorldModel(weaponTT.weaponmodel, true);
        weaponEnt.DisableDraw();
    }
    else
    {
        SetPropInt(CreateViewModel(null, true), "m_nModelIndex", GetPropInt(weaponEnt, "m_iWorldModelIndex"))
    }
}

function CreateViewModel(modelName, weaponModel = false)
{
    local viewModel = SpawnEntityFromTable("tf_wearable_vm", { })
    if (modelName)
	    viewModel.SetModelSimple(modelName);
    SetPropBool(viewModel, "m_bForcePurgeFixedupStrings", true);
    self.EquipWearableViewModel(viewModel);
    viewModel.ValidateScriptScope();
    viewModel.GetScriptScope().characterName <- characterName;
    if (weaponModel)
        weaponModels.push(viewModel);
	return viewModel;
}

function CreateWorldModel(modelName, weaponModel = false)
{
    local worldModel = SpawnEntityFromTable("tf_wearable", { });
	worldModel.SetModelSimple(modelName);
    SetPropBool(worldModel, "m_bForcePurgeFixedupStrings", true);
    SetPropBool(worldModel, "m_bValidatedAttachedEntity", true);
    SetPropBool(worldModel, "m_AttributeManager.m_Item.m_bInitialized", true);
	SetPropEntity(worldModel, "m_hOwnerEntity", self);
    EntFireByHandle(worldModel, "SetParent", "!activator", 0, self, self);
    worldModel.ValidateScriptScope();
    worldModel.GetScriptScope().characterName <- characterName;
    if (weaponModel)
        weaponModels.push(worldModel);
	return worldModel;
}