lastWeaponEnt <- null;

AddTimer(-1, -10, function()
{
    local weaponEnt = self.GetActiveWeapon();

    if (weaponEnt == lastWeaponEnt)
        return;
    lastWeaponEnt = weaponEnt;
    if (!weaponEnt)
        return;

    local weaponScript = weaponEnt.GetScriptScope();
    if ("OnSwitch" in weaponScript)
        weaponScript.OnSwitch(self, weaponScript.weaponTT, weaponEnt);
    if ("weaponTT" in weaponScript)
        RefreshCharacter(true);
});

function CreateWeapon(weaponTT)
{
    local weaponEnt = Entities.CreateByClassname(weaponTT.baseclass);
    SetPropInt(weaponEnt, "m_AttributeManager.m_Item.m_iItemDefinitionIndex", weaponTT.baseid);
    SetPropBool(weaponEnt, "m_AttributeManager.m_Item.m_bInitialized", true);
    SetPropBool(weaponEnt, "m_bValidatedAttachedEntity", true);
	SetPropBool(weaponEnt, "m_bClientSideAnimation", true);
    weaponEnt.SetTeam(self.GetTeam());
    weaponEnt.SetOwner(self);
	SetPropEntity(weaponEnt, "m_hOwnerEntity", self);
    SetPropBool(weaponEnt, "m_bForcePurgeFixedupStrings", true);
    Entities.DispatchSpawn(weaponEnt);
    return weaponEnt;
}

function EquipWeapon(weaponTT)
{
    local weaponEnt = CreateWeapon(weaponTT);
    self.Weapon_Equip(weaponEnt);
    //EntFireByHandle(worldModel, "SetParent", "!activator", 0, self, self);
    if ("OnEquip" in weaponTT)
        weaponTT.OnEquip(self, weaponTT, weaponEnt);

    if ("animmodel" in weaponTT)
    {
        weaponEnt.SetModelSimple(weaponTT.animmodel);
        weaponEnt.SetCustomViewModelModelIndex(GetModelIndex(weaponTT.animmodel));
        SetPropInt(weaponEnt, "m_iViewModelIndex", GetModelIndex(weaponTT.animmodel));
    }

    weaponEnt.ValidateScriptScope();
    weaponEnt.GetScriptScope().weaponTT <- weaponTT;
    if ("OnSwitch" in weaponTT)
        weaponEnt.GetScriptScope().OnSwitch <- weaponTT.OnSwitch;

    if ("OnFire" in weaponTT)
        IncludeScript("_charlib/weapon_events.nut", weaponEnt.GetScriptScope())

    return weaponEnt;
}