IncludeScript("gungame/gungame/announcer.nut")
IncludeScript("gungame/gungame/weapon_list.nut")
IncludeScript("gungame/gungame/weapon_order.nut")
IncludeScript("gungame/gungame/scoreboard.nut")

::gunGameProgress <- player_collection(0);
::fragLimit <- 14;

OnGameEvent("player_death_post", 20, function(victim, params)
{
    if (!IsValidRound())
        return;
    local attacker = GetPlayerFromParams(params, "attacker");

    if (attacker && attacker != victim)
    {
        local weaponTT = GetCurrentGunGameWeapon(attacker);
        local killsRequired = safeget(weaponTT, "gungame_kills", 1);
        if (GetKills2(attacker) >= killsRequired)
        {
            SetKills2(attacker, 0);
            if (params.weapon == "shovel" || weaponTT != GetWeaponTypeByName("golden_crowbar")) //todo hardcode
                SwitchToNextWeapon(attacker);
        }
    }
});

OnGameEvent("player_death_post", 0, function(player, params)
{
    if (!IsValidRound())
        return;
    local attacker = GetPlayerFromParams(params, "attacker");
    if (attacker && attacker != player)
    {
        local particle = SpawnEntityFromTable("info_particle_system", {
            effect_name = "medic_megaheal_red_shower",
            origin = attacker.GetCenter(),
            angles = attacker.EyeAngles(),
            start_active = 1
        })
        EntFireByHandle(particle, "SetParent", "!activator", 0, attacker, attacker);
        EntFireByHandle(particle, "kill", "", 1.05, null, null);

        particle = SpawnEntityFromTable("info_particle_system", {
            effect_name = "medic_megaheal_red",
            origin = attacker.GetOrigin(),
            angles = attacker.EyeAngles(),
            start_active = 1
        })
        EntFireByHandle(particle, "SetParent", "!activator", 0, attacker, attacker);
        EntFireByHandle(particle, "kill", "", 1.05, null, null);

        AddTimer(0.1, 0, function() {
            if (IsValidPlayer(attacker))
                attacker.SetHealth(clampCeiling(attacker.GetHealth() + 5, attacker.GetMaxHealth()));
        }, particle);
    }
});

function ConvertToMerc(player)
{
    if (!IsCustomCharacter(player))
        ConvertToCustomCharacter(player, "gungame/gungame/mercenary.nut");
}

function SwitchToNextWeapon(player)
{
    local progress = gunGameProgress[player.entindex()]++;
    if (progress >= fragLimit - 1)
    {
        EndRound(player);
        return;
    }

    FireCustomEvent("next_weapon", {
        "userid": player.GetUserID()
    });
    if (!GetPersistentVar("disable_overlays", false))
        player.SetScriptOverlayMaterial("gungame/ui/" + GetCurrentGunGameWeapon(player).names[0] + "_to_" + GetNextGunGameWeapon(player).names[0]);

    if ("SwitchToNextWeapon" in player.GetScriptScope())
    {
        //todo hardcode
        local isScoped = player.InCond(TF_COND_AIMING) && player.GetActiveWeapon() && player.GetActiveWeapon().GetClassname() == "tf_weapon_sniperrifle";
        RunWithDelay(isScoped ? 1 : -1, function() {
            player.RemoveCond(TF_COND_AIMING);
            SwitchToNextWeapon();
        }, player)
    }
}

OnGameEvent("player_team", 0, function(player, params)
{
    if (params.team < 2)
        player.SetScriptOverlayMaterial("");
});