::GUNGAME_WEAPON_POOLS <- [
    [
        ["rocket_launcher", "original"],
        ["airstrike", "black_box", "liberty_launcher"],
        ["flamethrower"],
        ["minigun", "tomislav"],
        ["scattergun", "shotgun", "family_business"],
    ],
    [
        ["grenade_launcher", "loch_n_load", "loose_cannon"],
        ["sticky_launcher", "quickie_launcher"],
        ["direct_hit", "beggars_bazooka", "dragons_fury"],
        //["eyelander_and_targe", "persuader_and_screen"],
        ["sniper_rifle", "awper_hand"],
        ["shortstop", "force_a_nature"],
        ["smg", "syringe_gun"],
        ["revolver", "ambassador"],
        ["pistol"/*, "pocket_pistol"*/],
    ],
    [
        ["golden_crowbar"],
        ["victory"]
    ]
]

::GUNGAME_ORDER <- [];

::BuildWeaponPool <- function()
{
    foreach(majorSet in GUNGAME_WEAPON_POOLS)
        foreach(set in majorSet)
            GUNGAME_ORDER.push(set[RandomInt(0, set.len() - 1)]);
    if (GetPersistentVar("no_flame", false))
        for (local i = 0; i < GUNGAME_ORDER.len(); i++)
            if (GUNGAME_ORDER[i] == "flamethrower" || GUNGAME_ORDER[i] == "dragons_fury")
                GUNGAME_ORDER[i] = "shotgun";
}
BuildWeaponPool();

::GetCurrentGunGameWeapon <- function(player)
{
    local index = clampCeiling(
        gunGameProgress[player.entindex()],
        GUNGAME_ORDER.len() - 1);
    return GetWeaponTypeByName(GUNGAME_ORDER[index]);
}

::GetNextGunGameWeapon <- function(player)
{
    local index = clampCeiling(
        gunGameProgress[player.entindex()] + 1,
        GUNGAME_ORDER.len() - 1);
    return GetWeaponTypeByName(GUNGAME_ORDER[index]);
}
